function [truth, a, err, trans] = find_best_overlap(truth, a);

opts = optimset('Display', 'off');
[t1,r1] = lsqnonlin(@error_flip, [truth(1,:) 0], [], [], opts, truth, a);
[t2,r2] = lsqnonlin(@error_noflip, [truth(1,:) 0], [], [], opts, truth, a);
if (r1 < r2)
    a = trans_flip(a, t1, 0);
    err = r1 / size(a,1);
    trans = [t1 1];
else
    a = trans_noflip(a, t2, 0);
    err = r2 / size(a,1);
    trans = [t2 0];
end

function e = error_flip(trans, truth, a);
b = trans_flip(a, trans, 0) - truth;
e = [b(:,1); b(:,2)];

function e = error_noflip(trans, truth, a);
b = trans_noflip(a, trans, 0) - truth;
e = [b(:,1); b(:,2)];

function d = dists(a, b);
d = a - b;
d = sqrt(d(:,1).^2 + d(:,2).^2);
