function generate_tossim_input(filename, dist);

US_PER_CM = 30;

mkdir(filename);

s = sprintf('%s/index', filename);
fididx = fopen(s, 'w');

for i = 1:size(dist,1),
    s = sprintf('%s/node%04d.in', filename, i);
    fid = fopen(s, 'w');
    fprintf(fid, 'node 0 ID 00:00:%02x:%02x\n', bitshift(i,-8), bitand(i,255));
    neighbors = find(dist(:,i));
    ndist = 0;
    for j = 1:size(neighbors,1),
        neigh = neighbors(j);
        fprintf(fid, 'node %d ID 00:00:%02x:%02x\n', ...
            j, bitshift(neigh,-8), bitand(neigh,255));
        fprintf(fid, '%d %d %d\n', 0, j, round(dist(i, neigh)*US_PER_CM));
        ndist = ndist+1;
        neighbors2 = find(dist(:,neigh));
        for k = 1:size(neighbors2,1),
            neigh2 = neighbors2(k);
            if (neigh2 == i)
                tf = 1;
                loc = 0;
            else
                [tf, loc] = ismember(neigh2, neighbors);
            end
            if ~tf
                continue;
            end
            fprintf(fid, '%d %d %d\n', j, loc, ...
                round(dist(neigh, neigh2)*US_PER_CM));
            ndist = ndist+1;
        end
    end
    fprintf(fididx, 'node%04d.in %d %d\n', i, size(neighbors,1)+1, ndist);
    fclose(fid);
end
fclose(fididx);

fprintf('TOSSIM cricket distance input files written to "%s/"\n', filename);
