function phase3(dir, first, last, plotit, cn)

[ids, tx, ty] = textread([dir '/truth'], '%s %f %f');
truth = [tx ty];

num_pairs = 0;
pairs = zeros(0,2);
i = 1;
while 1,
    name = sprintf('%s/%02d/index', dir, i);
    try,
        idx{i} = textread(name,'%s');
    catch,
        break;
    end
    for j = 1:i-1,
        [s, a, b] = intersect(idx{j},idx{i});
        if size(s,1) >= 4,
            pairs = [pairs; j i];
            num_pairs = num_pairs + 1;
            ai{num_pairs} = a;
            bi{num_pairs} = b;
        end    
    end
    i = i + 1;
end

num_dirs = i - 1;
pairs

i = first;
while i <= last,
    for j=1:num_dirs,
        name = sprintf('%s/%02d/loc%04d', dir, j, i);
        try,
            loc{j} = load(name);
        catch,
            break;
        end
    end
    v = zeros(num_pairs,1);
    for j = 1:num_pairs,
        p = pairs(j,:);
        a = loc{p(1)}(ai{j},:);
        b = loc{p(2)}(bi{j},:);
        valid = find((a(:,3) ~= 0.0) & (b(:,3) ~= 0.0));
        a = a(valid,1:2);
        b = b(valid,1:2);
        if (size(a,1) >= 3),
            v(j) = 1;
            [na, nb, err, trans{j}] = find_best_overlap(a, b);
        end
    end
    ps = find(v == 1);
    list = [2];
    found = list;
    for j = 1:num_dirs,
        path{j} = zeros(0, 2);
    end
    while 1,
        newl = [];
        for l = list,
            newps = ps;
            for j = ps',
                if (l == pairs(j,1)) && ~ismember(pairs(j,2),found),
                    newl = [newl pairs(j,2)];
                    found = [found pairs(j,2)];
                    path{pairs(j,2)} = [j 0; path{pairs(j,1)}];
                    newps = setdiff(newps,j);
                end
                if (l == pairs(j,2)) && ~ismember(pairs(j,1),found),
                    newl = [newl pairs(j,1)];
                    found = [found pairs(j,1)];
                    path{pairs(j,1)} = [j 1; path{pairs(j,2)}];
                    newps = setdiff(newps,j);
                end
            end
            ps = newps;
        end
        if length(newl) == 0,
            break;
        end
        list = newl;
    end
    tset = zeros(size(truth,1),1);
    tcomp = zeros(size(truth,1),2);
    clear a;
    for j = 1:num_dirs,
        valid = find(loc{j}(:,3) ~= 0.0);
        a{j} = loc{j}(valid,1:2);
        nidx = idx{j}(valid,:);
        [newids, ti, ci] = intersect(ids, nidx);
        for p = path{j}',
            a{j} = transform(a{j}, trans{p(1)}, p(2));
        end
        for k = 1:size(ti,1),
            if ~tset(ti(k)),
                tcomp(ti(k),:) = [a{j}(ci(k),:)];
                tset(ti(k)) = 1;
            end
        end
    end
    valid = find(tset ~= 0);
    t = truth(valid,:);
    b = tcomp(valid,:);
    [na, nb, err, ttran] = find_best_overlap(t, b);
    fprintf('%02d. num = %d, err = %f\n', i, size(na,1), err);
    if (plotit)
        figure(1);
        clf;
        %hold on;
        styles = ['.ox+*'];
        colors = ['rgbmk'];
        for j = 1:num_dirs,
            a{j} = transform(a{j}, ttran, 0);
            plot(a{j}(:,1), a{j}(:,2), [styles(j) colors(j)]);
            hold on;
        end
        %axis equal;
        axis([-150 450 -150 300]);
        for k = 1:num_dirs,
            labels{k} = sprintf('Cluster %d', k);
        end
        legend(labels, 4);
        exportfig(1, 'clusters.eps', 'Format', 'eps',...
            'width', 6, 'height', 4.3, 'FontSize', 1,...
            'Resolution', 300, 'Color', 'cmyk');
        p = plot_nodes(na, nb, cn, 145);
        legend(p, 'Localized positions', 'Ground truth', 4);
        %axis equal;
        axis([-150 450 -150 300]);
        exportfig(2, 'clusters_err.eps', 'Format', 'eps',...
            'width', 6, 'height', 4.3, 'FontSize', 1,...
            'Resolution', 300);
        exportfig(2, 'clusters_err.png', 'Format', 'png',...
            'width', 6, 'height', 4.3, 'FontSize', 1,...
            'Resolution', 150, 'Color', 'cmyk');
        %pause;
    end
    i = i+1;
end
